# Class BioModelSet

java.lang.Object
org.jmol.modelsetbio.BioModelSet

public class BioModelSet extends Object

## Constructor Summary

Constructors
Constructor
Description
`BioModelSet()`

## Method Summary

Modifier and Type
Method
Description
`void`
`calcAllRasmolHydrogenBonds(BS bsA, BS bsB, Lst<Bond> vHBonds, boolean nucleicOnly, int nMax, boolean dsspIgnoreHydrogens, BS bsHBonds, int dsspVersion)`
only for base models, not trajectories
`void`
`calcSelectedMonomersCount()`
`void`
`calculateAllPolymers(Group[] groups, int groupCount, int baseGroupIndex, BS modelsExcluded)`
`String`
`calculateAllStructuresExcept(BS alreadyDefined, boolean asDSSP, boolean doReport, boolean dsspIgnoreHydrogen, boolean setStructure, boolean includeAlpha, int version)`
`String`
`calculateAllStuctures(BS bsAtoms, boolean asDSSP, boolean doReport, boolean dsspIgnoreHydrogen, boolean setStructure, int version)`
`void`
`calculateStraightnessAll()`
`int`
`calculateStruts(BS bs1, BS bs2)`
`String`
`getAllDefaultStructures(BS bsAtoms, BS bsModified)`
`Map<String,String>`
`getAllHeteroList(int modelIndex)`
`void`
`getAllPolymerInfo(BS bs, Map<String, Lst<Map<String,Object>>> info)`
`void`
`getAllPolymerPointsAndVectors(BS bs, Lst<P3[]> vList, boolean isTraceAlpha, float sheetSmoothing)`
`BS`
`getAllSequenceBits(String specInfo, BS bsAtoms, BS bsResult)`
`boolean`
`getAminoAcidValenceAndCharge(String s, String atomName, int[] aaRet)`
`BS`
`getAtomBitsBS(int tokType, BS bsInfo, BS bs)`
`BS`
`getAtomBitsStr(int tokType, String specInfo, BS bs)`
`int`
`getBioPolymerCountInModel(int modelIndex)`
`String`
`getFullProteinStructureState(BS bsAtoms, int mode)`
`BS`
`getGroupsWithinAll(int nResidues, BS bs)`
`BS`
`getIdentifierOrNull(String identifier)`
`boolean`
`mutate(BS bs, String group, String[] sequence, String alphaType, float[] phipsi)`
`void`
`recalculateAllPolymers(BS bsModelsExcluded, Group[] groups)`
`void`
`recalculatePoints(int modelIndex)`
`BioModelSet`
`set(Viewer vwr, ModelSet ms)`
`void`
`setAllConformation(BS bsAtoms)`
`void`
`setAllProteinType(BS bs, STR type)`
called from state STRUCTURE command
`void`
`setAllStructureList(Map<STR,float[]> structureList)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### BioModelSet

public BioModelSet()

## Method Details

### set

public BioModelSet set(Viewer vwr, ModelSet ms)

### calcAllRasmolHydrogenBonds

public void calcAllRasmolHydrogenBonds(BS bsA, BS bsB, Lst<Bond> vHBonds, boolean nucleicOnly, int nMax, boolean dsspIgnoreHydrogens, BS bsHBonds, int dsspVersion)
only for base models, not trajectories

Parameters:
  `bsA` -
  `bsB` -
  `vHBonds` - will be null for autobonding
  `nucleicOnly` -
  `nMax` -
  `dsspIgnoreHydrogens` -
  `bsHBonds` -
  `dsspVersion` - 1 or 2

### calcSelectedMonomersCount

public void calcSelectedMonomersCount()

### calculateAllPolymers

public void calculateAllPolymers(Group[] groups, int groupCount, int baseGroupIndex, BS modelsExcluded)

### calculateAllStructuresExcept

public String calculateAllStructuresExcept(BS alreadyDefined, boolean asDSSP, boolean doReport, boolean dsspIgnoreHydrogen, boolean setStructure, boolean includeAlpha, int version)

### calculateAllStuctures

public String calculateAllStuctures(BS bsAtoms, boolean asDSSP, boolean doReport, boolean dsspIgnoreHydrogen, boolean setStructure, int version)

### calculateStraightnessAll

public void calculateStraightnessAll()

### calculateStruts

public int calculateStruts(BS bs1, BS bs2)

### getAllDefaultStructures

public String getAllDefaultStructures(BS bsAtoms, BS bsModified)

### getAllHeteroList

public Map<String,String> getAllHeteroList(int modelIndex)

### getAllPolymerInfo

public void getAllPolymerInfo(BS bs, Map<String, Lst<Map<String,Object>>> info)

### getAllPolymerPointsAndVectors

public void getAllPolymerPointsAndVectors(BS bs, Lst<P3[]> vList, boolean isTraceAlpha, float sheetSmoothing)

### getAllSequenceBits

public BS getAllSequenceBits(String specInfo, BS bsAtoms, BS bsResult)

### getAtomBitsBS

public BS getAtomBitsBS(int tokType, BS bsInfo, BS bs)

### getAtomBitsStr

public BS getAtomBitsStr(int tokType, String specInfo, BS bs)

### getBioPolymerCountInModel

public int getBioPolymerCountInModel(int modelIndex)

Parameters:
  `modelIndex` -
Returns:
  number of polymers

### getFullProteinStructureState

public String getFullProteinStructureState(BS bsAtoms, int mode)

### getGroupsWithinAll

public BS getGroupsWithinAll(int nResidues, BS bs)

### getIdentifierOrNull

public BS getIdentifierOrNull(String identifier)

### mutate

public boolean mutate(BS bs, String group, String[] sequence, String alphaType, float[] phipsi)

### recalculateAllPolymers

public void recalculateAllPolymers(BS bsModelsExcluded, Group[] groups)

### recalculatePoints

public void recalculatePoints(int modelIndex)

### setAllConformation

public void setAllConformation(BS bsAtoms)

### setAllProteinType

public void setAllProteinType(BS bs, STR type)
called from state STRUCTURE command

Parameters:
  `bs` -
  `type` -

### setAllStructureList

public void setAllStructureList(Map<STR,float[]> structureList)

### getAminoAcidValenceAndCharge

public boolean getAminoAcidValenceAndCharge(String s, String atomName, int[] aaRet)